package com.manalejandro.mongodbcrud.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.servlet.error.ErrorController;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

import com.manalejandro.mongodbcrud.forms.IndexForm;
import com.manalejandro.mongodbcrud.model.Item;
import com.manalejandro.mongodbcrud.services.ItemService;
import com.manalejandro.mongodbcrud.vo.IndexVO;

@Controller
public class IndexController implements ErrorController {

	private ItemService itemService;

	@Autowired
	public IndexController(ItemService itemService) {
		this.itemService = itemService;
	}

	@GetMapping("/")
	public String index(final @ModelAttribute IndexForm indexForm, final Model model) {
		IndexVO indexVO = new IndexVO();
		indexVO.getListItem().addAll(itemService.getAll());
		model.addAttribute("indexVO", indexVO);
		return "index";
	}

	@GetMapping("/{id}/edit")
	public String editItem(final @PathVariable String id, final Model model) {
		IndexVO indexVO = new IndexVO();
		Item item = itemService.getItem(id);
		if (item != null) {
			indexVO.setId(item.getId());
			indexVO.setNombre(item.getNombre());
			indexVO.setApellido1(item.getApellido1());
			indexVO.setApellido2(item.getApellido2());
			model.addAttribute("indexVO", indexVO);
			return "edit";
		} else {
			return "redirect:/index";
		}
	}
	
	@PostMapping("/{id}/save")
	public String saveItem(final @ModelAttribute IndexForm indexForm, final Model model) {
		return null;
	}

	@GetMapping("/error")
	public String getErrorPath() {
		return "error";
	}

}
